; Windows NT version 5 for the C128
;
; SYSTEM version 5.1
; (c) 1990 (!) by Nicolas TORMO
; http://www.imaginet.fr/~ntormo/
;
; previous version of SYSTEM uses indirect calls between $4000 / $4200
; in order to be simple to upgrade. Assembler onto PC has enough power to
; forget it ! So next version will be direct adressing.

. INCLUDE KERNAL.ASM

* = $4000      ; will change soon, may be for $8000

; Memory manager
;
SAVBNK = $4000 ; use this to allow ROM call in your subprog.
RCLBNK = $4003 ; return to previous memory config. must be use afer SAVBNK
SWPVAR = $4006 ; swap between BASIC data bank. Not yet implemented feature
               ; A      0 stacks
               ;        1 system
               ;        2 main prog
MULTI  = $4009 ; made A * X, ouput at $1716
DIV    = $400C ; made (A,X) / Y, output at $1716
               ; A      <
               ; X      >
               ; Y
STA#0  = $400F ; previous subprg for data transfer
               ; A      <source
               ; X      >source
               ; Y      <dest
STA#1  = $4012 ; previous subprg for data transfer
               ; A      >dest
               ; X      <lenght
               ; Y      >lenght
T00    = $4015 ; Tranfer memory from bank 0 to bank 0. use STA#0 and #1 first
T01    = $4018 ; same but bank 0 to bank 1
T10    = $401B ; same but bank 1 to bank 0
T11    = $401E ; same but bank 1 to bank 1

;Screen manager
;
PRPSCN = $4021 ; previous subprog for screen transfer
SAVSCN = $4024 ; move screen to bank 1, as a lifo stack
RCLSCN = $4027 ; get back screen from bank 1, as a lifo stack
PRPLGN = $402A ; set the line of screen output
               ; X      line
               ; ouput  $B0    screen adress
                        $B2    color adress
STACAR = $402D ; write a caracter to screen. use PRPLGN first
               ; A      screen code caracter
               ; Y      column
               ; $1C21  color
RCLCAR = $4030 ; get a caracter from screen. use PRPLGN first
               ; Y      column
               ; output A       caracter
               ;        $1C22   color
FRAME1 = $4033 ; set upper left corner window operations
               ; X      line
               ; Y      column
FRAME2 = $4036 ; set lower right corner for window operations
               ; X      line
               ; Y      column
PRPTIF = $4039 ; previous subprog
GETTIF = $403C ; screen copy feature, use FRAME1 and 2 first
SHWTIF = $403F ; screen paste feature, use FRAME1 and 2 first
SLCTWN = $4042 ; use joystick to select a window
ASCSCN = $4045 ; Petscii to screen code
SCNASC = $4048 ; screen code to petscii

;Window manager
;
CDRDRW = $404B ; draw a frame on screen
	       ; A	0	rectangular
               ;        1       smooth
               ; use FRAME1 and 2 before
TITLE  = $404E ; draw the title of the window
               ; $1C48,9        16 bit adress in bank#1 of name (basic format)
               ; use FRAME1 before
ASCVT  = $4051 ; draw a horizontal lift, use FRAME1 and 2 before
ASCVT  = $4054 ; draw a vertical lift, use FRAME1 and 2 before
WINCLR = $4057 ; Clear the window
WINUSE = $405A ; define writing zone, for BSOUT ouput or BASIC print
TITOLD = $405D ; change color of title when drawing a new window
WINDEF = $4060 ; Define and draw a window
               ; A      bit 0   set, draw frame
               ;        bit 1   set, rectangular
               ;        bit 2   set, draw title
               ;        bit 3   flag : set, old title style
               ;        bit 4   set, draw vertical lift
               ;        bit 5   set, draw horizontal lift
               ;        bit 6   set, define use zone
               ;        bit 7   unused
               ; $1C48,9 same as $404E
               ; use FRAME1 and 2 before
               ; output $1C30 zone
WINPRP = $4063 ; previous subprog
WINSAV = $4066 ; save current window in a lifo stack
WINRCL = $4069 ; get previous window from lifo stack
WINNEW = $406C ; define and draw an new windows, save previous
               ; this is the main subprog of the window
               ; A      same as $4060
               ; X      <
               ; Y      >adress of title name, in bank#1
               ; output $1C30 zone
WINPRE = $406F ; recall previous window and set all her caracteristics

; Events manager
;
WINTST = $4072 ; test button of the window
               ; output A       0       close button
               ;                1       lift up button
               ;                2       lift down button
               ;                3       lift left button
               ;                4       lift right button
               ;                FF      none
BTNTST = $4075 ; test defined buttons
               ; ouput A        number of pressed button
ZNETST = $4078 ; test defined zones
               ; ouput A        number of zone pointed
BTNDEF = $407B ; define a button
               ; A      button number
               ; X      line
               ; Y      column
ZNEDEF = $407E ; define a zone
               ; A      zone number
               ; X      number of lines
               ; Y      number of columns
               ; FRAME1 set upper left corner
BTNSWP = $4081 ; swap button between on/off

; Windows manager : manage a 80x50 window in bank#1
;
WPRPLN = $4084 ; set line for i/o
               ; X      line
WSTACR = $4087 ; print a char in window, use WPRPLN before
               ; A      char
               ; Y      column
               ; $1C21  color
WRCLCR = $408A ; get a char from window, use WPRPLN before
               ; Y      column
               ; ouput  A       char
               ;        $1C22  color
WWINCL = $408D ; clear window
WWINNW = $4090 ; set new window
WINMAJ = $4093 ; update window refresh
WINAFF = $4096 ; refresh screen with window
WINGET = $4099 ; refresh windows with screen
WINBTN = $4096 ; move window if button pressed
WINPNT = $409F ; set x,y under mouse
               ; ouput  X       line
               ;        Y       column

;Font manager
;
CARMOV = $40A2 ; move char font
               ; A      0       from bank#1 to bank#0 (will be displayed)
               ;        1       from bank#0 to bank#1 (will be stored)
FNTMOV = $40A5 ; move font (I don't remember the difference with CARMOV (!?)
               ; A      0       from bank#1 to bank#0 (will be displayed)
               ;        1       from bank#0 to bank#1 (will be stored)
               ; X      number of font
CARPRP = $40A8 ; previous subprog
CARLOD = $40AB ; read char from font to buffer for modify
               ; A      number of char
CARSAV = $40AE ; save char form buffer to font
               ; A      number of char
CARRCP = $40B1 ; move buffer2 to buffer1 after special modify
CARUP  = $40B4 ; move char in buffer to up
CARDWN = $40B7 ; move char in buffer to down
CARLFT = $40BA ; move char in buffer to left
CARRGT = $40BD ; move char in buffer to right
CARINU = $40B4 ; switch char in buffer up/down
CARINL = $40B4 ; switch char in buffer left/right
CARRTC = $40C6 ; rotate char in buffer using "clock move"
CARRTU = $40C9 ; rotate char in buffer using "inverse clock move"
CARVID = $40CC ; set char in buffer to inverse video mode (switch each bit)
BSTBYT = $40CF ; print map of a byte to screen, use FRAME1 so set position
               ; A      byte
               ; $1C21  color
CARBST = $40D2 ; print buffer (current modify) to screen
               ; X      line
               ; Y      column

;Sprite manager: sprite zone for i/o is $3000 in bank#0
;                sprite zone for displaying is $0E00
;
SPTPRP = $40D5 ; previous subprogam
SPRLOD = $40D8 ; load a sprite form $3000 to buffer
               ; A      number of sprite
SPRSAV = $40DB ; save a sprite from buffer to $3000
               ; A      number of sprite
SPRPRP2= $40DE ; previous subprogam
SPTLOD2= $40E1 ; load a sprite from $0E00 to buffer
               ; A      number of sprite
SPTSAV2= $40E4 ; save a sprite from buffer to $0E00
               ; A      number of sprite
SPTMOU = $40E7 ; move sprite in buffer to up
SPTMOD = $40EA ; move sprite in buffer to down
SPTMOL = $40ED ; move sprite in buffer to left
SPTMOR = $40F0 ; move sprite in buffer to right
SPTRCP = $40F3 ; move buffer2 to buffer1 after special modify
SPTINU = $40F6 ; switch sprite in buffer up/down
SPTINL = $40F9 ; switch sprite in buffer left/right
SPTINV = $40FC ; set sprite in buffer to inverse video mode (switch each bit)
SPTBST = $40FF ; print sprite in buffer to screen
               ; X      line
               ; Y      column
